## shasta 0.10.0

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shasta)

# This is the top level cmake file for a Shasta build. 

# Before starting a build,
# run shasta/scripts/InstallPrerequisites-Ubuntu.sh
# or shasta/scripts/InstallPrerequisites-macOS.sh

# Use "cmake -D" to modify the options defined below 
# in each "option" line. For example, to turn off
# building the dynamic executable use
# cmake -DBUILD_DYNAMIC_EXECUTABLE=OFF



# Figure out if we are on Intel (as opposed to ARM).
set(X86_64 OFF)
if(${CMAKE_HOST_SYSTEM_PROCESSOR} MATCHES "x86_64")
    set(X86_64 ON)
endif()



# Figure out if we are on macOS.
set(MACOS OFF)
if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
    set(MACOS ON)
endif()



# Summarize the environment.
message(STATUS "Processor architecture is " ${CMAKE_HOST_SYSTEM_PROCESSOR})
message(STATUS "CMAKE_SYSTEM_NAME is " ${CMAKE_SYSTEM_NAME})
message(STATUS "MACOS is " ${MACOS})



# Decide what we want to build.
if(MACOS)
    # For MacOS, only do the static builds.
    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." OFF)
    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
else(MACOS)
    # For Linux, build everything except the AppImage.
    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
endif(MACOS)



# To build the static executable, we also need the static library.
if(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)
    set(BUILD_STATIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_STATIC_LIBRARY because it is needed for BUILD_STATIC_EXECUTABLE.")
endif(BUILD_STATIC_EXECUTABLE AND NOT BUILD_STATIC_LIBRARY)



# To build the dynamic executable, we also need the dynamic library.
if(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)
    set(BUILD_DYNAMIC_LIBRARY ON)
    message(STATUS "Turned on BUILD_DYNAMIC_LIBRARY because it is needed for BUILD_DYNAMIC_EXECUTABLE.")
endif(BUILD_DYNAMIC_EXECUTABLE AND NOT BUILD_DYNAMIC_LIBRARY)



# Write out what we will actually build.
message(STATUS "BUILD_STATIC_LIBRARY is " ${BUILD_STATIC_LIBRARY})
message(STATUS "BUILD_STATIC_EXECUTABLE is " ${BUILD_STATIC_EXECUTABLE})
message(STATUS "BUILD_DYNAMIC_LIBRARY is " ${BUILD_DYNAMIC_LIBRARY})
message(STATUS "BUILD_DYNAMIC_EXECUTABLE is " ${BUILD_DYNAMIC_EXECUTABLE})



# Option to build with -march=native.
option(BUILD_NATIVE "Build with -march=native." OFF)
message(STATUS "BUILD_NATIVE is " ${BUILD_NATIVE})



# Option to request a debug build.
option(BUILD_DEBUG "Make a debuggable build." OFF)
message(STATUS "BUILD_DEBUG is " ${BUILD_DEBUG})



# The BUILD_ID can be specified to identify the build
# This is normally used only when building a new GitHub release,
# in which case we use the following option when running Cmake:
# -DBUILD_ID="Shasta Release X.Y.Z"
# BUILD_ID should not contain a comma, otherwise the C preprocessor does not handle it correctly.
if(NOT DEFINED BUILD_ID)
    set(BUILD_ID "Shasta development build. This is not a released version.")
endif(NOT DEFINED BUILD_ID)
message(STATUS "BUILD_ID is: " ${BUILD_ID})



# Add the subdirectories we need.
if(BUILD_STATIC_LIBRARY)
    add_subdirectory(staticLibrary)
endif(BUILD_STATIC_LIBRARY)

if(BUILD_STATIC_EXECUTABLE)
    add_subdirectory(staticExecutable)
endif(BUILD_STATIC_EXECUTABLE)

if(BUILD_DYNAMIC_LIBRARY)
    add_subdirectory(dynamicLibrary)
endif(BUILD_DYNAMIC_LIBRARY)

if(BUILD_DYNAMIC_EXECUTABLE)
    add_subdirectory(dynamicExecutable)
endif(BUILD_DYNAMIC_EXECUTABLE)



# Install to the shasta-install directory.
set(CMAKE_INSTALL_PREFIX .)

# Install the scripts.
file(GLOB SCRIPTS scripts/*.py scripts/*.sh)
install(PROGRAMS ${SCRIPTS} DESTINATION shasta-install/bin)

# Install the configuration files.
install(DIRECTORY conf DESTINATION shasta-install USE_SOURCE_PERMISSIONS)

# Install the docs directory.
install(DIRECTORY docs DESTINATION shasta-install)

# The targets built in each subdirectory are
# installed by the cmake file of each subdirectory.

=== dynamicExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaDynamicExecutable)

# C++ dialect.
add_definitions(-std=c++17)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    # Address sanitizer does not work well with the Python API,
    # so it is commented out here. But it could be useful
    # to debug the dynamic executable. 
    # add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif()

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Definitions that control what components get built.
if(BUILD_WITH_HTTP_SERVER)
    add_definitions(-DSHASTA_HTTP_SERVER)
endif(BUILD_WITH_HTTP_SERVER)

add_definitions(-DSHASTA_PYTHON_API)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Define our executable.
add_executable(shastaDynamicExecutable ${SOURCES})
set_target_properties(shastaDynamicExecutable PROPERTIES OUTPUT_NAME "shastaDynamic")

# This is needed to make sure the executable looks for the shared
# library in the same directory.
set_target_properties(shastaDynamicExecutable PROPERTIES INSTALL_RPATH "\$ORIGIN")

# Libraries to link with.
if(X86_64)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono spoa cpu_features png z 
        lapack blas gfortran quadmath pthread)
else(X86_64)
    target_link_libraries(
        shastaDynamicExecutable
        shastaDynamicLibrary
        atomic boost_system boost_program_options boost_chrono spoa png z 
        lapack blas gfortran pthread)
endif(X86_64)

if(BUILD_DEBUG) 
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -fsanitize=address")
endif(BUILD_DEBUG)

# Install the dynamic executable into the bin directory.
install(TARGETS shastaDynamicExecutable DESTINATION shasta-install/bin)

# When install is complete, create the AppImage.
if(BUILD_APPIMAGE)
install(CODE "execute_process(COMMAND ${CMAKE_SOURCE_DIR}/AppImage/CreateAppImage.py shasta-install)")
endif(BUILD_APPIMAGE)

=== dynamicLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)

project(shastaDynamicLibrary)

# C++ dialect.
add_definitions(-std=c++17)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
    # Address sanitizer does not work well with the Python API,
    # so it is commented out here. But it could be useful
    # to debug the dynamic executable. 
    # add_definitions(-fsanitize=address)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Definitions that control what components get built.
if(BUILD_WITH_HTTP_SERVER)
    add_definitions(-DSHASTA_HTTP_SERVER)
endif(BUILD_WITH_HTTP_SERVER)

add_definitions(-DSHASTA_PYTHON_API)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Define our library.
add_library(shastaDynamicLibrary SHARED ${SOURCES})

# Make sure the library is named shasta.so.
set_target_properties(shastaDynamicLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaDynamicLibrary PROPERTIES PREFIX "")
set_target_properties(shastaDynamicLibrary PROPERTIES DEFINE_SYMBOL "")



# Python 3 and pybind11.
execute_process(COMMAND /usr/bin/python3-config --embed --libs OUTPUT_VARIABLE SHASTA_PYTHON_LIBRARIES)
execute_process(COMMAND python3 -m pybind11 --includes OUTPUT_VARIABLE SHASTA_PYTHON_INCLUDES)
add_definitions(${SHASTA_PYTHON_INCLUDES})
string(STRIP ${SHASTA_PYTHON_LIBRARIES} SHASTA_PYTHON_LIBRARIES)
SET(CMAKE_LINKER_FLAGS  "${CMAKE_LINKER_FLAGS} ${SHASTA_PYTHON_LIBRARIES}")



# Libraries to link with.
target_link_libraries(
    shastaDynamicLibrary 
     atomic png boost_program_options pthread z spoa lapack blas ${SHASTA_PYTHON_LIBRARIES})

# Install the shared library into the bin directory.
install(TARGETS shastaDynamicLibrary DESTINATION shasta-install/bin)

=== staticExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaStaticExecutable)

# C++ dialect.
add_definitions(-std=c++17)

# Compilation warnings.
if(NOT MACOS)
    add_definitions(-Wall -Wconversion -Wno-unused-result)
endif(NOT MACOS)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
    add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Definitions that control what components get built.
if(BUILD_WITH_HTTP_SERVER)
    add_definitions(-DSHASTA_HTTP_SERVER)
endif(BUILD_WITH_HTTP_SERVER)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Include directories required on macOS.
if(MACOS)
    set(Boost_USE_STATIC_LIBS ON)
    find_package(Boost REQUIRED COMPONENTS program_options chrono)
    include_directories(/usr/local/include/)
    include_directories(${Boost_INCLUDE_DIRS})
endif(MACOS)

# Define our executable.
add_executable(shastaStaticExecutable ${SOURCES})
set_target_properties(shastaStaticExecutable PROPERTIES OUTPUT_NAME "shasta")

# Request a static executable.
# For macOS, this is not supported, and we only link some of the libraries statically.
if(NOT MACOS)
    set_target_properties(shastaStaticExecutable PROPERTIES LINK_FLAGS "-static" )
endif(NOT MACOS)

# Libraries to link with.
if(MACOS)
    find_library(PNG_LIBRARY libpng.a REQUIRED)
    #find_library(Z_LIBRARY libz.a REQUIRED)
    target_link_libraries(
    shastaStaticExecutable 
    shastaStaticLibrary
    ${Boost_LIBRARIES} /usr/local/lib/libspoa.a ${PNG_LIBRARY} z
    "-framework Accelerate"
    pthread)
else(MACOS)
    # For arcane reasons, statically linking with the pthread
    # library on Linux requires "--whole-archive".
    if(X86_64)
        target_link_libraries(
            shastaStaticExecutable
            shastaStaticLibrary
            atomic boost_system boost_program_options boost_chrono spoa cpu_features png z
            lapack blas gfortran quadmath
            -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
    else(X86_64)
        target_link_libraries(
            shastaStaticExecutable
            shastaStaticLibrary
            atomic boost_system boost_program_options boost_chrono spoa png z
            lapack blas gfortran
            -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
    endif(X86_64) 
    
endif(MACOS)
  
# The static executable goes to the bin directory.
install(TARGETS shastaStaticExecutable DESTINATION shasta-install/bin)

=== staticLibrary/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaStaticLibrary)

# C++ dialect.
add_definitions(-std=c++17)

# Compilation warnings.
if(NOT MACOS)
    add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
endif(NOT MACOS)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
  add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Definitions that control what components get built.
if(BUILD_WITH_HTTP_SERVER)
    add_definitions(-DSHASTA_HTTP_SERVER)
endif(BUILD_WITH_HTTP_SERVER)

# Sources files.
file(GLOB SOURCES ../src/*.cpp)

# Include directory.
include_directories(../src)

# Include directories required on macOS.
if(MACOS)
    set(Boost_USE_STATIC_LIBS ON)
    find_package(Boost REQUIRED COMPONENTS program_options chrono)
    include_directories(/usr/local/include/)
    include_directories(${Boost_INCLUDE_DIRS})
endif(MACOS)

# Define our library.
add_library(shastaStaticLibrary STATIC ${SOURCES})

# Make sure the library is named shasta.a.
set_target_properties(shastaStaticLibrary PROPERTIES OUTPUT_NAME "shasta")
set_target_properties(shastaStaticLibrary PROPERTIES PREFIX "")
set_target_properties(shastaStaticLibrary PROPERTIES DEFINE_SYMBOL "")

# Install the static library into the bin directory.
install(TARGETS shastaStaticLibrary DESTINATION shasta-install/bin)

=== debian/changelog ===
shasta (0.10.0-2ubuntu1) lunar; urgency=low

  * Merge from Debian unstable. Remaining changes:
    - d/tests/run-unit-test: Disable shasta binary test as it requires too
      much memory, even with the configuration for big_packages.

 -- Steve Langasek <steve.langasek@ubuntu.com>  Thu, 08 Dec 2022 15:09:03 -0800

shasta (0.10.0-2) unstable; urgency=medium

  * Team upload.
  * Fix watch file
  * lintian-override for custom-library-search-path
  * Fix location of file in d/copyright

 -- Andreas Tille <tille@debian.org>  Tue, 06 Dec 2022 07:51:25 +0100

shasta (0.10.0-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 0.10.0
  * Bump Standards-Version to 4.6.1 (no changes needed)
  * Update install in acc with upstream renamed executable
  * Drop modify_cmakelists.patch, set needed vars from d/rules
  * Drop upstream patch
  * Refresh patches

 -- Nilesh Patra <nilesh@debian.org>  Sat, 28 May 2022 13:06:01 +0530

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/chanzuckerberg/shasta/tags .*/v?@ANY_VERSION@\.tar\.gz

## shasta 0.11.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,6 @@
 
 # Before starting a build,
 # run shasta/scripts/InstallPrerequisites-Ubuntu.sh
-# or shasta/scripts/InstallPrerequisites-macOS.sh
 
 # Use "cmake -D" to modify the options defined below 
 # in each "option" line. For example, to turn off
@@ -22,37 +21,17 @@
 
 
 
-# Figure out if we are on macOS.
-set(MACOS OFF)
-if (${CMAKE_SYSTEM_NAME} MATCHES "Darwin")
-    set(MACOS ON)
-endif()
-
-
-
 # Summarize the environment.
 message(STATUS "Processor architecture is " ${CMAKE_HOST_SYSTEM_PROCESSOR})
 message(STATUS "CMAKE_SYSTEM_NAME is " ${CMAKE_SYSTEM_NAME})
-message(STATUS "MACOS is " ${MACOS})
 
 
 
 # Decide what we want to build.
-if(MACOS)
-    # For MacOS, only do the static builds.
-    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
-    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
-    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." OFF)
-    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
-    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
-else(MACOS)
-    # For Linux, build everything except the AppImage.
-    option(BUILD_STATIC_LIBRARY "Build the static library." ON)
-    option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
-    option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
-    option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)
-    option(BUILD_WITH_HTTP_SERVER "Build with embedded HTTP server for debugging." ON)
-endif(MACOS)
+option(BUILD_STATIC_LIBRARY "Build the static library." ON)
+option(BUILD_STATIC_EXECUTABLE "Build the static executable." ON)
+option(BUILD_DYNAMIC_LIBRARY "Build the shared library." ON)
+option(BUILD_DYNAMIC_EXECUTABLE "Build the dynamic executable." OFF)

=== dynamicExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -2,7 +2,7 @@
 project(shastaDynamicExecutable)
 
 # C++ dialect.
-add_definitions(-std=c++17)
+add_definitions(-std=c++20)
 
 # Compilation warnings.
 add_definitions(-Wall -Wconversion -Wno-unused-result)
@@ -46,11 +46,6 @@
 # It can be removed if Boost is fixed.
 add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)
 
-# Definitions that control what components get built.
-if(BUILD_WITH_HTTP_SERVER)
-    add_definitions(-DSHASTA_HTTP_SERVER)
-endif(BUILD_WITH_HTTP_SERVER)
-
 add_definitions(-DSHASTA_PYTHON_API)
 
 # Source files
@@ -72,7 +67,7 @@
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
-        atomic boost_system boost_program_options boost_chrono spoa cpu_features png z 
+        atomic boost_system boost_program_options boost_chrono spoa png z 
         lapack blas gfortran quadmath pthread)
 else(X86_64)
     target_link_libraries(
@@ -89,8 +84,3 @@
 # Install the dynamic executable into the bin directory.
 install(TARGETS shastaDynamicExecutable DESTINATION shasta-install/bin)
 
-# When install is complete, create the AppImage.
-if(BUILD_APPIMAGE)
-install(CODE "execute_process(COMMAND ${CMAKE_SOURCE_DIR}/AppImage/CreateAppImage.py shasta-install)")
-endif(BUILD_APPIMAGE)
-

=== dynamicLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -3,7 +3,7 @@
 project(shastaDynamicLibrary)
 
 # C++ dialect.
-add_definitions(-std=c++17)
+add_definitions(-std=c++20)
 
 # Compilation warnings.
 add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
@@ -47,11 +47,6 @@
 # It can be removed if Boost is fixed.
 add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)
 
-# Definitions that control what components get built.
-if(BUILD_WITH_HTTP_SERVER)
-    add_definitions(-DSHASTA_HTTP_SERVER)
-endif(BUILD_WITH_HTTP_SERVER)
-
 add_definitions(-DSHASTA_PYTHON_API)
 
 # Sources files.

=== staticExecutable/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
project(shastaStaticExecutable)

# C++ dialect.
add_definitions(-std=c++20)

# Compilation warnings.
add_definitions(-Wall -Wconversion -Wno-unused-result)

# Optimization and debug options.
if(BUILD_DEBUG)
    add_definitions(-ggdb3)
    add_definitions(-O0)
else(BUILD_DEBUG)
    add_definitions(-g0)
    add_definitions(-O3)
    # NDEBUG is required to turn off SeqAn debug code.
    add_definitions(-DNDEBUG)
endif(BUILD_DEBUG)

# 16-byte compare and swap.
# This is recommended for dset64.hpp/dset64-gccAtomic.hpp".
# It's available only on x86 architectures.
if(X86_64)
    add_definitions(-mcx16)
endif(X86_64)

# Native build.
if(BUILD_NATIVE)
    add_definitions(-march=native)
endif(BUILD_NATIVE)

# Build id.
add_definitions(-DBUILD_ID=${BUILD_ID})

# Definitions needed to eliminate dependency on the boost system library.
add_definitions(-DBOOST_SYSTEM_NO_DEPRECATED)
add_definitions(-DBOOST_ERROR_CODE_HEADER_ONLY)

# This is needed to avoid some Boost warnings about deprecated messages.
# We canot fix this in Shasta as it is a Boost problem.
# It can be removed if Boost is fixed.
add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)

# Source files
file(GLOB SOURCES ../srcMain/*.cpp)

# Include directory.
include_directories(../src)

# Define our executable.
add_executable(shastaStaticExecutable ${SOURCES})
set_target_properties(shastaStaticExecutable PROPERTIES OUTPUT_NAME "shasta")

# Request a static executable.
set_target_properties(shastaStaticExecutable PROPERTIES LINK_FLAGS "-static" )

# Libraries to link with.
# For arcane reasons, statically linking with the pthread
# library on Linux requires "--whole-archive".
if(X86_64)
    target_link_libraries(
        shastaStaticExecutable
        shastaStaticLibrary
        atomic boost_system boost_program_options boost_chrono spoa png z
        lapack blas gfortran quadmath
        -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
else(X86_64)
    target_link_libraries(
        shastaStaticExecutable
        shastaStaticLibrary
        atomic boost_system boost_program_options boost_chrono spoa png z
        lapack blas gfortran
        -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
endif(X86_64) 
  
# The static executable goes to the bin directory.
install(TARGETS shastaStaticExecutable DESTINATION shasta-install/bin)

=== staticLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -2,12 +2,10 @@
 project(shastaStaticLibrary)
 
 # C++ dialect.
-add_definitions(-std=c++17)
+add_definitions(-std=c++20)
 
 # Compilation warnings.
-if(NOT MACOS)
-    add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
-endif(NOT MACOS)
+add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
 
 # Optimization and debug options.
 if(BUILD_DEBUG)
@@ -44,24 +42,11 @@
 # It can be removed if Boost is fixed.
 add_definitions(-DBOOST_ALLOW_DEPRECATED_HEADERS)
 
-# Definitions that control what components get built.
-if(BUILD_WITH_HTTP_SERVER)
-    add_definitions(-DSHASTA_HTTP_SERVER)
-endif(BUILD_WITH_HTTP_SERVER)
-
 # Sources files.
 file(GLOB SOURCES ../src/*.cpp)
 
 # Include directory.
 include_directories(../src)
-
-# Include directories required on macOS.
-if(MACOS)
-    set(Boost_USE_STATIC_LIBS ON)
-    find_package(Boost REQUIRED COMPONENTS program_options chrono)
-    include_directories(/usr/local/include/)
-    include_directories(${Boost_INCLUDE_DIRS})
-endif(MACOS)
 
 # Define our library.
 add_library(shastaStaticLibrary STATIC ${SOURCES})

=== docs/PythonApi/Makefile ===
# Makefile for Sphinx documentation
#

# You can set these variables from the command line.
SPHINXOPTS    =
SPHINXBUILD   = sphinx-build
PAPER         =
BUILDDIR      = _build

# User-friendly check for sphinx-build
ifeq ($(shell which $(SPHINXBUILD) >/dev/null 2>&1; echo $$?), 1)
$(error The '$(SPHINXBUILD)' command was not found. Make sure you have Sphinx installed, then set the SPHINXBUILD environment variable to point to the full path of the '$(SPHINXBUILD)' executable. Alternatively you can add the directory with the executable to your PATH. If you don't have Sphinx installed, grab it from http://sphinx-doc.org/)
endif

# Internal variables.
PAPEROPT_a4     = -D latex_paper_size=a4
PAPEROPT_letter = -D latex_paper_size=letter
ALLSPHINXOPTS   = -d $(BUILDDIR)/doctrees $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .
# the i18n builder cannot share the environment and doctrees with the others
I18NSPHINXOPTS  = $(PAPEROPT_$(PAPER)) $(SPHINXOPTS) .

.PHONY: help
help:
	@echo "Please use \`make <target>' where <target> is one of"
	@echo "  html       to make standalone HTML files"
	@echo "  dirhtml    to make HTML files named index.html in directories"
	@echo "  singlehtml to make a single large HTML file"
	@echo "  pickle     to make pickle files"
	@echo "  json       to make JSON files"
	@echo "  htmlhelp   to make HTML files and a HTML help project"
	@echo "  qthelp     to make HTML files and a qthelp project"
	@echo "  applehelp  to make an Apple Help Book"
	@echo "  devhelp    to make HTML files and a Devhelp project"
	@echo "  epub       to make an epub"
	@echo "  latex      to make LaTeX files, you can set PAPER=a4 or PAPER=letter"
	@echo "  latexpdf   to make LaTeX files and run them through pdflatex"
	@echo "  latexpdfja to make LaTeX files and run them through platex/dvipdfmx"
	@echo "  text       to make text files"
	@echo "  man        to make manual pages"
	@echo "  texinfo    to make Texinfo files"
	@echo "  info       to make Texinfo files and run them through makeinfo"
	@echo "  gettext    to make PO message catalogs"
	@echo "  changes    to make an overview of all changed/added/deprecated items"
	@echo "  xml        to make Docutils-native XML files"
	@echo "  pseudoxml  to make pseudoxml-XML files for display purposes"
	@echo "  linkcheck  to check all external links for integrity"
	@echo "  doctest    to run all doctests embedded in the documentation (if enabled)"
	@echo "  coverage   to run coverage check of the documentation (if enabled)"

.PHONY: clean
clean:
	rm -rf $(BUILDDIR)/*

.PHONY: html
html:
	$(SPHINXBUILD) -b html $(ALLSPHINXOPTS) $(BUILDDIR)/html
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/html."

.PHONY: dirhtml
dirhtml:
	$(SPHINXBUILD) -b dirhtml $(ALLSPHINXOPTS) $(BUILDDIR)/dirhtml
	@echo
	@echo "Build finished. The HTML pages are in $(BUILDDIR)/dirhtml."

.PHONY: singlehtml
singlehtml:
	$(SPHINXBUILD) -b singlehtml $(ALLSPHINXOPTS) $(BUILDDIR)/singlehtml
	@echo
	@echo "Build finished. The HTML page is in $(BUILDDIR)/singlehtml."

.PHONY: pickle
pickle:
	$(SPHINXBUILD) -b pickle $(ALLSPHINXOPTS) $(BUILDDIR)/pickle
	@echo
	@echo "Build finished; now you can process the pickle files."

.PHONY: json
json:
	$(SPHINXBUILD) -b json $(ALLSPHINXOPTS) $(BUILDDIR)/json
	@echo
	@echo "Build finished; now you can process the JSON files."

.PHONY: htmlhelp
htmlhelp:
	$(SPHINXBUILD) -b htmlhelp $(ALLSPHINXOPTS) $(BUILDDIR)/htmlhelp
	@echo
	@echo "Build finished; now you can run HTML Help Workshop with the" \
	      ".hhp project file in $(BUILDDIR)/htmlhelp."

.PHONY: qthelp
qthelp:
	$(SPHINXBUILD) -b qthelp $(ALLSPHINXOPTS) $(BUILDDIR)/qthelp
	@echo
	@echo "Build finished; now you can run "qcollectiongenerator" with the" \
	      ".qhcp project file in $(BUILDDIR)/qthelp, like this:"
	@echo "# qcollectiongenerator $(BUILDDIR)/qthelp/Shasta.qhcp"
	@echo "To view the help file:"
	@echo "# assistant -collectionFile $(BUILDDIR)/qthelp/Shasta.qhc"

.PHONY: applehelp
applehelp:
	$(SPHINXBUILD) -b applehelp $(ALLSPHINXOPTS) $(BUILDDIR)/applehelp
	@echo
	@echo "Build finished. The help book is in $(BUILDDIR)/applehelp."
	@echo "N.B. You won't be able to view it unless you put it in" \
	      "~/Library/Documentation/Help or install it in your application" \
	      "bundle."

.PHONY: devhelp
devhelp:
	$(SPHINXBUILD) -b devhelp $(ALLSPHINXOPTS) $(BUILDDIR)/devhelp
	@echo
	@echo "Build finished."
	@echo "To view the help file:"
	@echo "# mkdir -p $$HOME/.local/share/devhelp/Shasta"
	@echo "# ln -s $(BUILDDIR)/devhelp $$HOME/.local/share/devhelp/Shasta"
	@echo "# devhelp"

.PHONY: epub
epub:
	$(SPHINXBUILD) -b epub $(ALLSPHINXOPTS) $(BUILDDIR)/epub
	@echo
	@echo "Build finished. The epub file is in $(BUILDDIR)/epub."

.PHONY: latex
latex:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo
	@echo "Build finished; the LaTeX files are in $(BUILDDIR)/latex."
	@echo "Run \`make' in that directory to run these through (pdf)latex" \
	      "(use \`make latexpdf' here to do that automatically)."

.PHONY: latexpdf
latexpdf:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through pdflatex..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: latexpdfja
latexpdfja:
	$(SPHINXBUILD) -b latex $(ALLSPHINXOPTS) $(BUILDDIR)/latex
	@echo "Running LaTeX files through platex and dvipdfmx..."
	$(MAKE) -C $(BUILDDIR)/latex all-pdf-ja
	@echo "pdflatex finished; the PDF files are in $(BUILDDIR)/latex."

.PHONY: text
text:
	$(SPHINXBUILD) -b text $(ALLSPHINXOPTS) $(BUILDDIR)/text
	@echo
	@echo "Build finished. The text files are in $(BUILDDIR)/text."

.PHONY: man
man:
	$(SPHINXBUILD) -b man $(ALLSPHINXOPTS) $(BUILDDIR)/man
	@echo
	@echo "Build finished. The manual pages are in $(BUILDDIR)/man."

.PHONY: texinfo
texinfo:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo
	@echo "Build finished. The Texinfo files are in $(BUILDDIR)/texinfo."
	@echo "Run \`make' in that directory to run these through makeinfo" \
	      "(use \`make info' here to do that automatically)."

.PHONY: info
info:
	$(SPHINXBUILD) -b texinfo $(ALLSPHINXOPTS) $(BUILDDIR)/texinfo
	@echo "Running Texinfo files through makeinfo..."
	make -C $(BUILDDIR)/texinfo info
	@echo "makeinfo finished; the Info files are in $(BUILDDIR)/texinfo."

.PHONY: gettext
gettext:
	$(SPHINXBUILD) -b gettext $(I18NSPHINXOPTS) $(BUILDDIR)/locale
	@echo
	@echo "Build finished. The message catalogs are in $(BUILDDIR)/locale."

.PHONY: changes
changes:
	$(SPHINXBUILD) -b changes $(ALLSPHINXOPTS) $(BUILDDIR)/changes
	@echo
	@echo "The overview file is in $(BUILDDIR)/changes."

.PHONY: linkcheck
linkcheck:
	$(SPHINXBUILD) -b linkcheck $(ALLSPHINXOPTS) $(BUILDDIR)/linkcheck
	@echo
	@echo "Link check complete; look for any errors in the above output " \
	      "or in $(BUILDDIR)/linkcheck/output.txt."

.PHONY: doctest
doctest:
	$(SPHINXBUILD) -b doctest $(ALLSPHINXOPTS) $(BUILDDIR)/doctest
	@echo "Testing of doctests in the sources finished, look at the " \
	      "results in $(BUILDDIR)/doctest/output.txt."

.PHONY: coverage
coverage:
	$(SPHINXBUILD) -b coverage $(ALLSPHINXOPTS) $(BUILDDIR)/coverage
	@echo "Testing of coverage in the sources finished, look at the " \
	      "results in $(BUILDDIR)/coverage/python.txt."

.PHONY: xml
xml:
	$(SPHINXBUILD) -b xml $(ALLSPHINXOPTS) $(BUILDDIR)/xml
	@echo
	@echo "Build finished. The XML files are in $(BUILDDIR)/xml."

.PHONY: pseudoxml
pseudoxml:
	$(SPHINXBUILD) -b pseudoxml $(ALLSPHINXOPTS) $(BUILDDIR)/pseudoxml
	@echo
	@echo "Build finished. The pseudo-XML files are in $(BUILDDIR)/pseudoxml."

=== debian/changelog ===
shasta (0.11.1-1) unstable; urgency=medium

  * Team upload
  * Upstream repository moved from github.com/chanzuckerberg/shasta
    to github.com/paoloshasta/shasta

 -- Andreas Tille <tille@debian.org>  Mon, 12 Dec 2022 09:50:09 +0100

=== debian/control ===
Source: shasta
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Shayan Doust <hello@shayandoust.me>
Section: science
Priority: optional
Build-Depends: debhelper-compat (= 13),
               dh-python,
               dh-exec,
               cmake,
               patchelf,
               chrpath,
               libboost-all-dev,
               libpng-dev,
               ncbi-blast+,
               python3-sphinx,
               python3-dev,
               libseqan2-dev,
               libspoa-dev,
               python3-pybind11,
               libcpu-features-dev [any-amd64],
               libcereal-dev,
               libblas-dev,
               liblapack-dev,
               gfortran
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/med-team/shasta
Vcs-Git: https://salsa.debian.org/med-team/shasta.git
Homepage: https://github.com/chanzuckerberg/shasta
Rules-Requires-Root: no

Package: shasta
Architecture: any-amd64 arm64
# even if one comments out the sections that forbid compilation on other archs
# one gets this error message:
# undefined reference to `__sync_bool_compare_and_swap_16'
# see src/dset64.hpp for more details
Depends: ${misc:Depends},
         ${shlibs:Depends},
         python3-shasta (= ${binary:Version}),
Description: nanopore whole genome assembly (binaries and scripts)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the executable binaries (tools) and
 accommodating scripts.

Package: python3-shasta
Architecture: any-amd64 arm64
Section: python
Depends: ${python3:Depends},
         ${shlibs:Depends},
         ${misc:Depends},
         ncbi-blast+
Description: nanopore whole genome assembly (dynamic library)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the dynamic library that can be interfaced and
 imported within Python.

Package: python3-shasta-doc
Architecture: all
Multi-Arch: foreign
Section: doc
Built-Using: ${sphinxdoc:Built-Using}
Depends: ${sphinxdoc:Depends},
         ${misc:Depends}
Recommends: shasta,
            python3-shasta
Description: nanopore whole genome assembly (documentation)
 De novo assembly from Oxford Nanopore reads. The goal of the Shasta long
 read assembler is to rapidly produce accurate assembled sequence using
 as input DNA reads generated by Oxford Nanopore flow cells.
 .
 Computational methods used by the Shasta assembler include:
 .
  * Using a run-length representation of the read sequence. This makes
    the assembly process more resilient to errors in homopolymer
    repeat counts, which are the most common type of errors in Oxford
    Nanopore reads.
 .
  * Using in some phases of the computation a representation of the read
    sequence based on markers, a fixed subset of short k-mers (k ≈ 10).
 .
 Shasta assembly quality is comparable or better than assembly quality
 achieved by other long read assemblers.
 .
 This package contains the documentation for the shasta and python3-shasta
 packages.

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

include /usr/share/dpkg/default.mk

# for hardening you might like to uncomment this:
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

DEB_HOST_MULTIARCH ?= $(shell dpkg-architecture -qDEB_HOST_MULTIARCH)
MULTIARCH_SONAME = shasta.cpython-$(shell py3versions -vd | sed 's/\.//')-$(DEB_HOST_MULTIARCH).so

%:
	dh $@ --with python3,sphinxdoc

override_dh_auto_configure:
	dh_auto_configure -- -DBUILD_ID=${DEB_VERSION_UPSTREAM} \
				-DBUILD_STATIC_EXECUTABLE=OFF \
				-DBUILD_DYNAMIC_EXECUTABLE=ON

override_dh_auto_build: export http_proxy=127.0.0.1:9
override_dh_auto_build: export https_proxy=127.0.0.1:9
override_dh_auto_build:
	dh_auto_build
	# Move shared library into sphinx documentation folder for doc generation
	find . -name "shasta.so" -exec cp {} docs/PythonApi/ \;
	PYTHONPATH=docs/PythonApi/ python3 -m sphinx -N -bhtml docs/PythonApi/ build/html # HTML generator

override_dh_install-arch:
	dh_install -a
	# Rename shastaDynamic to shasta for ease
	mv debian/shasta/usr/bin/shastaDynamic debian/shasta/usr/bin/shasta
	# The library is in a more unusual place (nested within /usr/lib), so modify
	# the ELF
	chrpath -r /usr/lib/python3/dist-packages \
		debian/shasta/usr/bin/shasta
	patchelf \
		--replace-needed shasta.so $(MULTIARCH_SONAME) \
		debian/shasta/usr/bin/shasta

execute_after_dh_python3-arch:
	patchelf \
		--set-soname $(MULTIARCH_SONAME) \
		$(CURDIR)/debian/python3-shasta/usr/lib/python3/dist-packages/$(MULTIARCH_SONAME)

override_dh_missing:
	# No need to install docker files
	find debian/tmp -type d -name docker | xargs rm -rf
	# static library should not be installed
	find debian/tmp -name shasta.a -delete
	# dynamic library was installed manually before - so remove it from debian/tmp
	find debian/tmp -name shasta.so -delete
	# 11MB of generated docs should go into a separate package if this is considered sensible
	# FIXME: for the moment do not install these
	find debian/tmp -name docs | xargs rm -rf
	# Remove rest of files which have already been installed
	rm -rf debian/tmp/${CURDIR}
	dh_missing --list-missing

## shasta 0.12.0

=== dynamicExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 add_definitions(-std=c++20)
 
 # Compilation warnings.
-add_definitions(-Wall -Wconversion -Wno-unused-result)
+add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi)
 
 # Optimization and debug options.
 if(BUILD_DEBUG)
@@ -67,13 +67,13 @@
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
-        atomic boost_system boost_program_options boost_chrono spoa png z 
+        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z 
         lapack blas gfortran quadmath pthread)
 else(X86_64)
     target_link_libraries(
         shastaDynamicExecutable
         shastaDynamicLibrary
-        atomic boost_system boost_program_options boost_chrono spoa png z 
+        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z 
         lapack blas gfortran pthread)
 endif(X86_64)

=== dynamicLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -6,7 +6,7 @@
 add_definitions(-std=c++20)
 
 # Compilation warnings.
-add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
+add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi)
 
 # Optimization and debug options.
 if(BUILD_DEBUG)
@@ -77,7 +77,7 @@
 # Libraries to link with.
 target_link_libraries(
     shastaDynamicLibrary 
-     atomic png boost_program_options pthread z spoa lapack blas ${SHASTA_PYTHON_LIBRARIES})
+     atomic png boost_program_options boost_serialization pthread z spoa lapack blas ${SHASTA_PYTHON_LIBRARIES})
 
 # Install the shared library into the bin directory.
 install(TARGETS shastaDynamicLibrary DESTINATION shasta-install/bin)

=== staticExecutable/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 add_definitions(-std=c++20)
 
 # Compilation warnings.
-add_definitions(-Wall -Wconversion -Wno-unused-result)
+add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi)
 
 # Optimization and debug options.
 if(BUILD_DEBUG)
@@ -62,14 +62,14 @@
     target_link_libraries(
         shastaStaticExecutable
         shastaStaticLibrary
-        atomic boost_system boost_program_options boost_chrono spoa png z
+        atomic boost_system boost_program_options boost_chrono boost_serialization  spoa png z
         lapack blas gfortran quadmath
         -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
 else(X86_64)
     target_link_libraries(
         shastaStaticExecutable
         shastaStaticLibrary
-        atomic boost_system boost_program_options boost_chrono spoa png z
+        atomic boost_system boost_program_options boost_chrono boost_serialization spoa png z
         lapack blas gfortran
         -Wl,--whole-archive -lpthread -Wl,--no-whole-archive)
 endif(X86_64)

=== staticLibrary/CMakeLists.txt ===
--- 
+++ 
@@ -5,7 +5,7 @@
 add_definitions(-std=c++20)
 
 # Compilation warnings.
-add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs)
+add_definitions(-Wall -Wconversion -Wno-unused-result -Wno-trigraphs -Wno-psabi)
 
 # Optimization and debug options.
 if(BUILD_DEBUG)

=== debian/changelog ===
shasta (0.12.0-1build2) questing; urgency=medium

  * No-change rebuild for boost 1.88.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 11 Aug 2025 08:25:16 +0200

shasta (0.12.0-1build1) plucky; urgency=medium

  * No-change rebuild for Python 3.13 as the default.

 -- Matthias Klose <doko@ubuntu.com>  Fri, 03 Jan 2025 12:04:18 +0100

shasta (0.12.0-1) unstable; urgency=medium

  * New upstream version 0.12.0
  * gcc-13.patch: delete: applied upstream.
  * gcc-13-bis.patch: delete: applied upstream.
  * d/control: declare compliance to standards version 4.7.0.

 -- Étienne Mollier <emollier@debian.org>  Sun, 26 May 2024 18:05:55 +0200

shasta (0.11.1-5) unstable; urgency=medium

  * d/rules: meddle with RPATH only after dh_shlibdeps. (Closes: #1069370)

 -- Étienne Mollier <emollier@debian.org>  Wed, 08 May 2024 22:02:57 +0200

shasta (0.11.1-4) unstable; urgency=medium

  * gcc-13-bis.patch: new: fix ftbfs with gcc 13.2.0. (Closes: #1059139)

 -- Étienne Mollier <emollier@debian.org>  Wed, 20 Dec 2023 16:50:12 +0100

shasta (0.11.1-3) unstable; urgency=medium

  * d/t/run-unit-test: use older shasta config.
    The original test shipped with Nanopore-Sep2020 configuration file
    selected by shasta in the autopkgtest script.  This caused shasta to
    reserve 8GiB of RAM on CI test hosts, which is just the limit on the
    arm64 runners.  Dropping to the older Nanopore-Dec2019 configuration
    file causes shasta to reserve memory as needed instead of prefetching
    a huge amount of pages, causing out of memory conditions on runners.
    (Closes: #1053509)

 -- Étienne Mollier <emollier@debian.org>  Mon, 04 Dec 2023 16:48:02 +0100

shasta (0.11.1-2) unstable; urgency=medium

  * gcc-13.patch: new: fix build failures with gcc-13. (Closes: #1042196)
  * d/clean: remove build remnants.
  * d/control: add myself to uploaders.
  * d/control: split python3-dev build dependency.
    This is the first step of many to enable cross compilation.
  * d/control: declare compliance to standards version 4.6.2.
  * d/salsa-ci.yml: fix yaml invalid error caught by salsa.

 -- Étienne Mollier <emollier@debian.org>  Wed, 23 Aug 2023 17:26:58 +0200

=== debian/rules ===
--- 
+++ 
@@ -31,13 +31,6 @@
 	dh_install -a
 	# Rename shastaDynamic to shasta for ease
 	mv debian/shasta/usr/bin/shastaDynamic debian/shasta/usr/bin/shasta
-	# The library is in a more unusual place (nested within /usr/lib), so modify
-	# the ELF
-	chrpath -r /usr/lib/python3/dist-packages \
-		debian/shasta/usr/bin/shasta
-	patchelf \
-		--replace-needed shasta.so $(MULTIARCH_SONAME) \
-		debian/shasta/usr/bin/shasta
 
 execute_after_dh_python3-arch:
 	patchelf \
@@ -57,3 +50,12 @@
 	# Remove rest of files which have already been installed
 	rm -rf debian/tmp/${CURDIR}
 	dh_missing --list-missing
+
+execute_after_dh_shlibdeps:
+	# The library is in a more unusual place (nested within /usr/lib), so
+	# modify the ELF
+	chrpath -r /usr/lib/python3/dist-packages \
+		debian/shasta/usr/bin/shasta
+	patchelf \
+		--replace-needed shasta.so $(MULTIARCH_SONAME) \
+		debian/shasta/usr/bin/shasta

=== debian/watch ===
version=4

opts="filenamemangle=s%(?:.*?)?v?(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
https://github.com/paoloshasta/shasta/tags .*/v?@ANY_VERSION@\.tar\.gz
